"use strict"
Object.defineProperty(exports,"__esModule",{value:!0})
exports.CSSStyleDeclaration=void 0
var t=(e=require("css-tree"))&&e.__esModule?e:{default:e}
var e
var r=require("../css-tools")
const s=function(t){this.parentNode=t
this.properties=new Map
this.hasSynced=!1
this.styleAttr=null
this.styleValue=null
this.parseError=!1}
exports.CSSStyleDeclaration=s
s.prototype.clone=function(t){var e=this
var r={}
Object.keys(e).forEach((function(t){"parentNode"!==t&&(r[t]=e[t])}))
r=JSON.parse(JSON.stringify(r))
var i=new s(t)
Object.assign(i,r)
return i}
s.prototype.hasStyle=function(){this.addStyleHandler()}
s.prototype.addStyleHandler=function(){this.styleAttr={name:"style",value:null}
Object.defineProperty(this.parentNode.attrs,"style",{get:this.getStyleAttr.bind(this),set:this.setStyleAttr.bind(this),enumerable:!0,configurable:!0})
this.addStyleValueHandler()}
s.prototype.addStyleValueHandler=function(){Object.defineProperty(this.styleAttr,"value",{get:this.getStyleValue.bind(this),set:this.setStyleValue.bind(this),enumerable:!0,configurable:!0})}
s.prototype.getStyleAttr=function(){return this.styleAttr}
s.prototype.setStyleAttr=function(t){this.setStyleValue(t.value)
this.styleAttr=t
this.addStyleValueHandler()
this.hasSynced=!1}
s.prototype.getStyleValue=function(){return this.getCssText()}
s.prototype.setStyleValue=function(t){this.properties.clear()
this.styleValue=t
this.hasSynced=!1}
s.prototype._loadCssText=function(){if(!this.hasSynced){this.hasSynced=!0
if(this.styleValue&&0!==this.styleValue.length){var e=this.styleValue
var s={}
try{s=t.default.parse(e,{context:"declarationList",parseValue:!1})}catch(t){this.parseError=t
return}this.parseError=!1
var i=this
s.children.each((function(t){try{var e=(0,r.csstreeToStyleDeclaration)(t)
i.setProperty(e.name,e.value,e.priority)}catch(t){"Unknown node type: undefined"!==t.message&&(i.parseError=t)}}))}}}
s.prototype.getCssText=function(){var t=this.getProperties()
if(this.parseError)return this.styleValue
var e=[]
t.forEach((function(t,r){var s="important"===t.priority?"!important":""
e.push(r.trim()+":"+t.value.trim()+s)}))
return e.join(";")}
s.prototype._handleParseError=function(){this.parseError&&console.warn("Warning: Parse error when parsing inline styles, style properties of this element cannot be used. The raw styles can still be get/set using .attr('style').value. Error details: "+this.parseError)}
s.prototype._getProperty=function(t){if(void 0===t)throw Error("1 argument required, but only 0 present.")
var e=this.getProperties()
this._handleParseError()
return e.get(t.trim())}
s.prototype.getPropertyPriority=function(t){var e=this._getProperty(t)
return e?e.priority:""}
s.prototype.getPropertyValue=function(t){var e=this._getProperty(t)
return e?e.value:null}
s.prototype.item=function(t){if(void 0===t)throw Error("1 argument required, but only 0 present.")
var e=this.getProperties()
this._handleParseError()
return Array.from(e.keys())[t]}
s.prototype.getProperties=function(){this._loadCssText()
return this.properties}
s.prototype.removeProperty=function(t){if(void 0===t)throw Error("1 argument required, but only 0 present.")
this.hasStyle()
var e=this.getProperties()
this._handleParseError()
var r=this.getPropertyValue(t)
e.delete(t.trim())
return r}
s.prototype.setProperty=function(t,e,r){if(void 0===t)throw Error("propertyName argument required, but only not present.")
this.hasStyle()
var s=this.getProperties()
this._handleParseError()
var i={value:e.trim(),priority:r.trim()}
s.set(t.trim(),i)
return i}
