"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.PLUGINS = void 0;

exports.PLUGINS = function(data, info, plugins) {
  plugins.forEach((function(group) {
    switch (group[0].type) {
     case "perItem":
      data = perItem(data, info, group);
      break;

     case "perItemReverse":
      data = perItem(data, info, group, !0);
      break;

     case "full":
      data = function(data, info, plugins) {
        plugins.forEach((function(plugin) {
          plugin.active && (data = plugin.fn(data, plugin.params, info));
        }));
        return data;
      }(data, info, group);
    }
  }));
  return data;
};

function perItem(data, info, plugins, reverse) {
  return function monkeys(items) {
    items.content = items.content.filter((function(item) {
      reverse && item.content && monkeys(item);
      let filter = !0;
      for (let i = 0; filter && i < plugins.length; i++) {
        const plugin = plugins[i];
        plugin.active && !1 === plugin.fn(item, plugin.params, info) && (filter = !1);
      }
      !reverse && item.content && monkeys(item);
      return filter;
    }));
    return items;
  }(data);
}