"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

exports.name = "removeAttrs";

exports.type = "perItem";

exports.active = !1;

exports.description = "removes specified attributes";

exports.params = {
  elemSeparator: ":",
  preserveCurrentColor: !1,
  attrs: []
};

exports.fn = function(item, params) {
  Array.isArray(params.attrs) || (params.attrs = [ params.attrs ]);
  if (item.isElem()) {
    const elemSeparator = "string" == typeof params.elemSeparator ? params.elemSeparator : ":";
    const preserveCurrentColor = "boolean" == typeof params.preserveCurrentColor && params.preserveCurrentColor;
    params.attrs.map((function(pattern) {
      -1 === pattern.indexOf(elemSeparator) ? pattern = [ ".*", elemSeparator, pattern, elemSeparator, ".*" ].join("") : pattern.split(elemSeparator).length < 3 && (pattern = [ pattern, elemSeparator, ".*" ].join(""));
      return pattern.split(elemSeparator).map((function(value) {
        "*" === value && (value = ".*");
        return new RegExp([ "^", value, "$" ].join(""), "i");
      }));
    })).forEach((function(pattern) {
      pattern[0].test(item.elem) && item.eachAttr((function(attr) {
        const name = attr.name;
        const value = attr.value;
        preserveCurrentColor && "fill" === name && "currentColor" === value || preserveCurrentColor && "stroke" === name && "currentColor" === value || pattern[1].test(name) && pattern[2].test(attr.value) && item.removeAttr(name);
      }));
    }));
  }
};