"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

let editorNamespaces = require("./_collections").editorNamespaces;

exports.name = "removeEditorsNSData";

exports.type = "perItem";

exports.active = !0;

exports.description = "removes editors namespaces, elements and attributes";

const prefixes = [];

exports.params = {
  additionalNamespaces: []
};

exports.fn = function(item, params) {
  Array.isArray(params.additionalNamespaces) && (editorNamespaces = editorNamespaces.concat(params.additionalNamespaces));
  if (item.elem) {
    item.isElem("svg") && item.eachAttr((function(attr) {
      if ("xmlns" === attr.prefix && editorNamespaces.indexOf(attr.value) > -1) {
        prefixes.push(attr.local);
        item.removeAttr(attr.name);
      }
    }));
    item.eachAttr((function(attr) {
      prefixes.indexOf(attr.prefix) > -1 && item.removeAttr(attr.name);
    }));
    if (prefixes.indexOf(item.prefix) > -1) return !1;
  }
};