"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

exports.name = "removeUnusedNS";

exports.type = "full";

exports.active = !0;

exports.description = "removes unused namespaces declaration";

exports.params = {};

exports.fn = function(data) {
  let svgElem;
  const xmlnsCollection = [];
  function removeNSfromCollection(ns) {
    const pos = xmlnsCollection.indexOf(ns);
    pos > -1 && xmlnsCollection.splice(pos, 1);
  }
  data = function monkeys(items) {
    let i = 0;
    const length = items.content.length;
    for (;i < length; ) {
      const item = items.content[i];
      if (item.isElem("svg")) {
        item.eachAttr((function(attr) {
          "xmlns" === attr.prefix && attr.local && xmlnsCollection.push(attr.local);
        }));
        xmlnsCollection.length && (svgElem = item);
      }
      if (xmlnsCollection.length) {
        item.prefix && removeNSfromCollection(item.prefix);
        item.eachAttr((function(attr) {
          removeNSfromCollection(attr.prefix);
        }));
      }
      xmlnsCollection.length && item.content && monkeys(item);
      i++;
    }
    return items;
  }(data);
  xmlnsCollection.length && xmlnsCollection.forEach((function(name) {
    svgElem.removeAttr("xmlns:" + name);
  }));
  return data;
};