"use strict"
Object.defineProperty(exports,"__esModule",{value:!0})
exports.intersects=exports.js2path=exports.computeQuadraticBoundingBox=exports.computeCubicBoundingBox=exports.applyTransforms=exports.relative2absolute=exports.path2js=void 0
var t=require("../lib/svgo/tools")
var n=require("./_transforms")
var e=require("./_collections")
const a=e.attrsGroupsDefaults.presentation["stroke-width"]
const r=String.raw`[-+]?(?:\d*\.\d+|\d+\.?)(?:[eE][-+]?\d+)?\s*`
const o=String.raw`(?:\s,?\s*|,\s*)`
const s=`(${r})`+o
const i=`([01])${o}?`
const c=String.raw`(${r})${o}?(${r})`
const u=(s+"?").repeat(2)+s+i.repeat(2)+c
const l=/([MmLlHhVvCcSsQqTtAaZz])\s*/
const f=new RegExp(r,"g")
const h=new RegExp(u,"g")
const d=/[-+]?(\d*\.\d+|\d+\.?)(?:[eE][-+]?\d+)?/
exports.path2js=function(t){if(t.pathJS)return t.pathJS
const n={H:1,V:1,M:2,L:2,T:2,Q:4,S:4,C:6,A:7,h:1,v:1,m:2,l:2,t:2,q:4,s:4,c:6,a:7}
const e=[]
let a
let r=!1
t.attr("d").value.split(l).forEach((function(t){if(t){if(!r){if("M"!==t&&"m"!==t)return
r=!0}if(l.test(t)){a=t
"Z"!==a&&"z"!==a||e.push({instruction:"z"})}else{if("A"===a||"a"===a){const n=[]
for(let e;e=h.exec(t);)for(let t=1;t<e.length;t++)n.push(e[t])
t=n}else t=t.match(f)
if(!t)return
t=t.map(Number)
if("M"===a||"m"===a){e.push({instruction:0===e.length?"M":a,data:t.splice(0,2)})
a="M"===a?"L":"l"}for(const r=n[a];t.length;)e.push({instruction:a,data:t.splice(0,r)})}}}))
e.length&&"m"===e[0].instruction&&(e[0].instruction="M")
t.pathJS=e
return e}
const m=function(t){const n=[0,0]
const e=[0,0]
let a
return t.map((function(t){const r=t.instruction
const o=t.data&&t.data.slice()
if("M"===r){b(n,o)
b(e,o)}else if("mlcsqt".indexOf(r)>-1){for(a=0;a<o.length;a++)o[a]+=n[a%2]
b(n,o)
"m"===r&&b(e,o)}else if("a"===r){o[5]+=n[0]
o[6]+=n[1]
b(n,o)}else if("h"===r){o[0]+=n[0]
n[0]=o[0]}else if("v"===r){o[0]+=n[1]
n[1]=o[0]}else"MZLCSQTA".indexOf(r)>-1?b(n,o):"H"===r?n[0]=o[0]:"V"===r?n[1]=o[0]:"z"===r&&b(n,e)
return"z"===r?{instruction:"z"}:{instruction:r.toUpperCase(),data:o}}))}
exports.relative2absolute=m
exports.applyTransforms=function(r,o,s){if(!r.hasAttr("transform")||!r.attr("transform").value||r.someAttr((function(t){return~e.referencesProps.indexOf(t.name)&&~t.value.indexOf("url(")})))return o
const i=(0,n.transformsMultiply)((0,n.transform2js)(r.attr("transform").value))
const c=r.computedAttr("stroke")
const u=r.computedAttr("id")
const l=s.transformPrecision
let f
let h
if(c&&"none"!==c){if(!s.applyTransformsStroked||(i.data[0]!==i.data[3]||i.data[1]!==-i.data[2])&&(i.data[0]!==-i.data[3]||i.data[1]!==i.data[2]))return o
if(u){let t=r
let n=!1
do{t.hasAttr("stroke-width")&&(n=!0)}while(!t.hasAttr("id",u)&&!n&&(t=t.parentNode))
if(!n)return o}h=+Math.sqrt(i.data[0]*i.data[0]+i.data[1]*i.data[1]).toFixed(l)
if(1!==h){const n=r.computedAttr("stroke-width")||a
r.hasAttr("vector-effect")&&"non-scaling-stroke"===r.attr("vector-effect").value||(r.hasAttr("stroke-width")?r.attrs["stroke-width"].value=r.attrs["stroke-width"].value.trim().replace(d,(function(n){return(0,t.removeLeadingZero)(n*h)})):r.addAttr({name:"stroke-width",prefix:"",local:"stroke-width",value:n.replace(d,(function(n){return(0,t.removeLeadingZero)(n*h)}))}))}}else if(u)return o
o.forEach((function(t){if(t.data){if("h"===t.instruction){t.instruction="l"
t.data[1]=0}else if("v"===t.instruction){t.instruction="l"
t.data[1]=t.data[0]
t.data[0]=0}if("M"!==t.instruction||0===i.data[4]&&0===i.data[5]){if("a"===t.instruction){(0,n.transformArc)(t.data,i.data)
if(Math.abs(t.data[2])>80){const n=t.data[0]
const e=t.data[2]
t.data[0]=t.data[1]
t.data[1]=n
t.data[2]=e+(e>0?-90:90)}f=p(i.data,t.data[5],t.data[6])
t.data[5]=f[0]
t.data[6]=f[1]}else for(let n=0;n<t.data.length;n+=2){f=p(i.data,t.data[n],t.data[n+1])
t.data[n]=f[0]
t.data[n+1]=f[1]}t.coords[0]=t.base[0]+t.data[t.data.length-2]
t.coords[1]=t.base[1]+t.data[t.data.length-1]}else{f=p(i.data,t.data[0],t.data[1])
b(t.data,f)
b(t.coords,f)
i.data[4]=0
i.data[5]=0}}}))
r.removeAttr("transform")
return o}
function p(t,n,e){return[t[0]*n+t[2]*e+t[4],t[1]*n+t[3]*e+t[5]]}exports.computeCubicBoundingBox=function(t,n,e,a,r,o,s,i){let c=Number.POSITIVE_INFINITY
let u=Number.POSITIVE_INFINITY
let l=Number.NEGATIVE_INFINITY
let f=Number.NEGATIVE_INFINITY
t<c&&(c=t)
t>l&&(l=t)
s<c&&(c=s)
s>l&&(l=s)
const h=x(t,e,r,s)
for(let n=0;n<h.length;n++){const a=h[n]
if(a>=0&&a<=1){const n=g(a,t,e,r,s)
n<c&&(c=n)
n>l&&(l=n)}}n<u&&(u=n)
n>f&&(f=n)
i<u&&(u=i)
i>f&&(f=i)
const d=x(n,a,o,i)
for(let t=0;t<d.length;t++){const e=d[t]
if(e>=0&&e<=1){const t=g(e,n,a,o,i)
t<u&&(u=t)
t>f&&(f=t)}}return{minx:c,miny:u,maxx:l,maxy:f}}
function g(t,n,e,a,r){const o=1-t
return o*o*o*n+3*o*o*t*e+3*o*t*t*a+t*t*t*r}function x(t,n,e,a){const r=[-1,-1]
const o=2*n-t-e
const s=-Math.sqrt(-t*(e-a)+n*n-n*(e+a)+e*e)
const i=3*n-t-3*e+a
if(0!==i){r[0]=(o+s)/i
r[1]=(o-s)/i}return r}exports.computeQuadraticBoundingBox=function(t,n,e,a,r,o){let s=Number.POSITIVE_INFINITY
let i=Number.POSITIVE_INFINITY
let c=Number.NEGATIVE_INFINITY
let u=Number.NEGATIVE_INFINITY
t<s&&(s=t)
t>c&&(c=t)
r<s&&(s=r)
r>c&&(c=r)
const l=I(t,e,r)
if(l>=0&&l<=1){const n=M(l,t,e,r)
n<s&&(s=n)
n>c&&(c=n)}n<i&&(i=n)
n>u&&(u=n)
o<i&&(i=o)
o>u&&(u=o)
const f=I(n,a,o)
if(f>=0&&f<=1){const t=M(f,n,a,o)
t<i&&(i=t)
t>u&&(u=t)}return{minx:s,miny:i,maxx:c,maxy:u}}
function M(t,n,e,a){const r=1-t
return r*r*n+2*r*t*e+t*t*a}function I(t,n,e){let a=-1
const r=t-2*n+e
0!==r&&(a=(t-n)/r)
return a}exports.js2path=function(n,e,a){n.pathJS=e
a.collapseRepeated&&(e=function(t){let n
let e
return t.reduce((function(t,a){if(n&&a.data&&a.instruction===n.instruction)if("M"!==a.instruction)n=t[e]={instruction:n.instruction,data:n.data.concat(a.data),coords:a.coords,base:n.base}
else{n.data=a.data
n.coords=a.coords}else{t.push(a)
n=a
e=t.length-1}return t}),[])}(e))
n.attr("d").value=e.reduce((function(n,e){let r=""
e.data&&(r=(0,t.cleanupOutData)(e.data,a,e.instruction))
return n+(e.instruction+r)}),"")}
function b(t,n){t[0]=n[n.length-2]
t[1]=n[n.length-1]
return t}exports.intersects=function(t,n){if(t.length<3||n.length<3)return!1
const e=m(t).reduce(k,[])
const a=m(n).reduce(k,[])
if(e.maxX<=a.minX||a.maxX<=e.minX||e.maxY<=a.minY||a.maxY<=e.minY||e.every((function(t){return a.every((function(n){return t[t.maxX][0]<=n[n.minX][0]||n[n.maxX][0]<=t[t.minX][0]||t[t.maxY][1]<=n[n.minY][1]||n[n.maxY][1]<=t[t.minY][1]}))})))return!1
const r=e.map(E)
const o=a.map(E)
return r.some((function(t){return!(t.length<3)&&o.some((function(n){if(n.length<3)return!1
const e=[s(t,n,[1,0])]
const a=v(e[0])
let r=1e4
for(;;){if(0==r--){console.error("Error: infinite loop while processing mergePaths plugin.")
return!0}e.push(s(t,n,a))
if(T(a,e[e.length-1])<=0)return!1
if(N(e,a))return!0}}))}))
function s(t,n,e){return Y(i(t,e),i(n,v(e)))}function i(t,n){let e=n[1]>=0?n[0]<0?t.maxY:t.maxX:n[0]<0?t.minX:t.minY
let a=-1/0
let r
for(;(r=T(t[e],n))>a;){a=r
e=++e%t.length}return t[(e||t.length)-1]}}
function N(t,n){if(2===t.length){const e=t[1]
const a=t[0]
const r=v(t[1])
const o=Y(a,e)
if(T(r,o)>0)b(n,A(o,e))
else{b(n,r)
t.shift()}}else{const e=t[2]
const a=t[1]
const r=t[0]
const o=Y(a,e)
const s=Y(r,e)
const i=v(e)
const c=A(o,s)
const u=A(s,o)
if(T(c,i)>0)if(T(o,i)>0){b(n,c)
t.shift()}else{b(n,i)
t.splice(0,2)}else{if(!(T(u,i)>0))return!0
if(T(s,i)>0){b(n,u)
t.splice(1,1)}else{b(n,i)
t.splice(0,2)}}}return!1}function v(t){return[-t[0],-t[1]]}function Y(t,n){return[t[0]-n[0],t[1]-n[1]]}function T(t,n){return t[0]*n[0]+t[1]*n[1]}function A(t,n){const e=[-t[1],t[0]]
return T(e,v(n))<0?v(e):e}let X
function k(t,n,e,a){let r=t.length&&t[t.length-1]
const o=e&&a[e-1]
let s=r.length&&r[r.length-1]
const i=n.data
let c=s
switch(n.instruction){case"M":t.push(r=[])
break
case"H":l(r,[i[0],s[1]])
break
case"V":l(r,[s[0],i[0]])
break
case"Q":l(r,i.slice(0,2))
X=[i[2]-i[0],i[3]-i[1]]
break
case"T":if("Q"===o.instruction||"T"===o.instruction){c=[s[0]+X[0],s[1]+X[1]]
l(r,c)
X=[i[0]-c[0],i[1]-c[1]]}break
case"C":l(r,[.5*(s[0]+i[0]),.5*(s[1]+i[1])])
l(r,[.5*(i[0]+i[2]),.5*(i[1]+i[3])])
l(r,[.5*(i[2]+i[4]),.5*(i[3]+i[5])])
X=[i[4]-i[2],i[5]-i[3]]
break
case"S":if("C"===o.instruction||"S"===o.instruction){l(r,[s[0]+.5*X[0],s[1]+.5*X[1]])
c=[s[0]+X[0],s[1]+X[1]]}l(r,[.5*(c[0]+i[0]),.5*(c[1]+i[1])])
l(r,[.5*(i[0]+i[2]),.5*(i[1]+i[3])])
X=[i[2]-i[0],i[3]-i[1]]
break
case"A":{const t=w.apply(0,s.concat(i))
for(let n;(n=t.splice(0,6).map(u)).length;){l(r,[.5*(s[0]+n[0]),.5*(s[1]+n[1])])
l(r,[.5*(n[0]+n[2]),.5*(n[1]+n[3])])
l(r,[.5*(n[2]+n[4]),.5*(n[3]+n[5])])
t.length&&l(r,s=n.slice(-2))}break}}i&&i.length>=2&&l(r,i.slice(-2))
return t
function u(t,n){return t+s[n%2]}function l(n,e){if(!n.length||e[1]>n[n.maxY][1]){n.maxY=n.length
t.maxY=t.length?Math.max(e[1],t.maxY):e[1]}if(!n.length||e[0]>n[n.maxX][0]){n.maxX=n.length
t.maxX=t.length?Math.max(e[0],t.maxX):e[0]}if(!n.length||e[1]<n[n.minY][1]){n.minY=n.length
t.minY=t.length?Math.min(e[1],t.minY):e[1]}if(!n.length||e[0]<n[n.minX][0]){n.minX=n.length
t.minX=t.length?Math.min(e[0],t.minX):e[0]}n.push(e)}}function E(t){t.sort((function(t,n){return t[0]===n[0]?t[1]-n[1]:t[0]-n[0]}))
const n=[]
let e=0
let a=0
for(let r=0;r<t.length;r++){for(;n.length>=2&&S(n[n.length-2],n[n.length-1],t[r])<=0;)n.pop()
if(t[r][1]<t[e][1]){e=r
a=n.length}n.push(t[r])}const r=[]
let o=t.length-1
let s=0
for(let n=t.length;n--;){for(;r.length>=2&&S(r[r.length-2],r[r.length-1],t[n])<=0;)r.pop()
if(t[n][1]>t[o][1]){o=n
s=r.length}r.push(t[n])}r.pop()
n.pop()
const i=n.concat(r)
i.minX=0
i.maxX=n.length
i.minY=a
i.maxY=(n.length+s)%i.length
return i}function S(t,n,e){return(n[0]-t[0])*(e[1]-t[1])-(n[1]-t[1])*(e[0]-t[0])}function w(t,n,e,a,r,o,s,i,c,u){const l=120*Math.PI/180
const f=Math.PI/180*(+r||0)
let h=[]
let d
let m
let p
let g
const x=function(t,n,e){return t*Math.cos(e)-n*Math.sin(e)}
const M=function(t,n,e){return t*Math.sin(e)+n*Math.cos(e)}
if(u){p=u[0]
g=u[1]
m=u[2]
d=u[3]}else{n=M(t=x(t,n,-f),n,-f)
const r=(t-(i=x(i,c,-f)))/2
const u=(n-(c=M(i,c,-f)))/2
let l=r*r/(e*e)+u*u/(a*a)
if(l>1){l=Math.sqrt(l)
e*=l
a*=l}const h=e*e
const I=a*a
const b=(o===s?-1:1)*Math.sqrt(Math.abs((h*I-h*u*u-I*r*r)/(h*u*u+I*r*r)))
m=b*e*u/a+(t+i)/2
d=b*-a*r/e+(n+c)/2
p=Math.asin(((n-d)/a).toFixed(9))
g=Math.asin(((c-d)/a).toFixed(9))
p=t<m?Math.PI-p:p
g=i<m?Math.PI-g:g
p<0&&(p=2*Math.PI+p)
g<0&&(g=2*Math.PI+g)
s&&p>g&&(p-=2*Math.PI)
!s&&g>p&&(g-=2*Math.PI)}let I=g-p
if(Math.abs(I)>l){const t=g
const n=i
const o=c
g=p+l*(s&&g>p?1:-1)
h=w(i=m+e*Math.cos(g),c=d+a*Math.sin(g),e,a,r,0,s,n,o,[g,t,m,d])}I=g-p
const b=Math.cos(p)
const N=Math.sin(p)
const v=Math.cos(g)
const Y=Math.sin(g)
const T=Math.tan(I/4)
const A=4/3*e*T
const X=4/3*a*T
const k=[-A*N,X*b,i+A*Y-t,c-X*v-n,i-t,c-n]
if(u)return k.concat(h)
{h=k.concat(h)
const t=[]
for(let n=0,e=h.length;n<e;n++)t[n]=n%2?M(h[n-1],h[n],f):x(h[n],h[n+1],f)
return t}}