"use strict"
Object.defineProperty(exports,"__esModule",{value:!0})
exports.JS2SVG=void 0
const t=require("../../plugins/_collections").elemsGroups.textContent.concat("title")
const e={doctypeStart:"<!DOCTYPE",doctypeEnd:">",procInstStart:"<?",procInstEnd:"?>",tagOpenStart:"<",tagOpenEnd:">",tagCloseStart:"</",tagCloseEnd:">",tagShortStart:"<",tagShortEnd:"/>",attrStart:'="',attrEnd:'"',commentStart:"\x3c!--",commentEnd:"--\x3e",cdataStart:"<![CDATA[",cdataEnd:"]]>",textStart:"",textEnd:"",indent:4,regEntities:/[&'"<>]/g,regValEntities:/[&"<>]/g,encodeEntity:function(t){return n[t]},pretty:!1,useShortTags:!0}
const n={"&":"&amp;","'":"&apos;",'"':"&quot;",">":"&gt;","<":"&lt;"}
exports.JS2SVG=function(t,e){return new i(e).convert(t)}
function i(t){this.config=t?Object.assign({},e,t):Object.assign({},e)
const n=this.config.indent
"number"!=typeof n||isNaN(n)?"string"!=typeof n&&(this.config.indent="    "):this.config.indent=n<0?"\t":" ".repeat(n)
if(this.config.pretty){this.config.doctypeEnd+="\n"
this.config.procInstEnd+="\n"
this.config.commentEnd+="\n"
this.config.cdataEnd+="\n"
this.config.tagShortEnd+="\n"
this.config.tagOpenEnd+="\n"
this.config.tagCloseEnd+="\n"
this.config.textEnd+="\n"}this.indentLevel=0
this.textContext=null}i.prototype.convert=function(t){let e=""
if(t.content){this.indentLevel++
t.content.forEach((function(t){t.elem?e+=this.createElem(t):t.text?e+=this.createText(t.text):t.doctype?e+=this.createDoctype(t.doctype):t.processinginstruction?e+=this.createProcInst(t.processinginstruction):t.comment?e+=this.createComment(t.comment):t.cdata&&(e+=this.createCDATA(t.cdata))}),this)}this.indentLevel--
return{data:e,info:{width:this.width,height:this.height}}}
i.prototype.createIndent=function(){let t=""
this.config.pretty&&!this.textContext&&(t=this.config.indent.repeat(this.indentLevel-1))
return t}
i.prototype.createDoctype=function(t){return this.config.doctypeStart+t+this.config.doctypeEnd}
i.prototype.createProcInst=function(t){return this.config.procInstStart+t.name+" "+t.body+this.config.procInstEnd}
i.prototype.createComment=function(t){return this.config.commentStart+t+this.config.commentEnd}
i.prototype.createCDATA=function(t){return this.createIndent()+this.config.cdataStart+t+this.config.cdataEnd}
i.prototype.createElem=function(n){if(n.isElem("svg")&&n.hasAttr("width")&&n.hasAttr("height")){this.width=n.attr("width").value
this.height=n.attr("height").value}if(n.isEmpty())return this.config.useShortTags?this.createIndent()+this.config.tagShortStart+n.elem+this.createAttrs(n)+this.config.tagShortEnd:this.createIndent()+this.config.tagShortStart+n.elem+this.createAttrs(n)+this.config.tagOpenEnd+this.config.tagCloseStart+n.elem+this.config.tagCloseEnd
{let i=this.config.tagOpenStart
let o=this.config.tagOpenEnd
let c=this.config.tagCloseStart
let s=this.config.tagCloseEnd
let r=this.createIndent()
let a=""
let h=""
let g=""
if(this.textContext){i=e.tagOpenStart
o=e.tagOpenEnd
c=e.tagCloseStart
s=e.tagCloseEnd
r=""}else if(n.isElem(t)){this.config.pretty&&(a+=r+this.config.indent)
this.textContext=n}h+=this.convert(n).data
if(this.textContext===n){this.textContext=null
this.config.pretty&&(g="\n")}return r+i+n.elem+this.createAttrs(n)+o+a+h+g+this.createIndent()+c+n.elem+s}}
i.prototype.createAttrs=function(t){let e=""
t.eachAttr((function(t){void 0!==t.value?e+=" "+t.name+this.config.attrStart+String(t.value).replace(this.config.regValEntities,this.config.encodeEntity)+this.config.attrEnd:e+=" "+t.name}),this)
return e}
i.prototype.createText=function(t){return this.createIndent()+this.config.textStart+t.replace(this.config.regEntities,this.config.encodeEntity)+(this.textContext?"":this.config.textEnd)}
