"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.default = void 0;

var _svgo = require("./svgo");

var _svgoLite = require("./svgo-lite");

var _configLite = require("./svgo/config-lite");

var _default2 = require("../plugins/__default");

var PLUGINS_MAP = function(obj) {
  if (obj && obj.__esModule) return obj;
  if (null === obj || "object" != typeof obj && "function" != typeof obj) return {
    default: obj
  };
  var cache = _getRequireWildcardCache();
  if (cache && cache.has(obj)) return cache.get(obj);
  var newObj = {};
  var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var key in obj) if (Object.prototype.hasOwnProperty.call(obj, key)) {
    var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
    desc && (desc.get || desc.set) ? Object.defineProperty(newObj, key, desc) : newObj[key] = obj[key];
  }
  newObj.default = obj;
  cache && cache.set(obj, newObj);
  return newObj;
}(require("../plugins/__all"));

function _getRequireWildcardCache() {
  if ("function" != typeof WeakMap) return null;
  var cache = new WeakMap;
  _getRequireWildcardCache = function() {
    return cache;
  };
  return cache;
}

var _default = Object.assign(_svgo.SVGO, {
  SVGO_LITE: _svgoLite.SVGO_LITE,
  CONFIG_LITE: _configLite.CONFIG_LITE,
  PLUGINS_DEFAULT_LIST: _default2.PLUGINS_DEFAULT_LIST,
  PLUGINS_MAP
});

exports.default = _default;