"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.svgoCssSelectAdapter = void 0;

var obj;

const svgoCssSelectAdapter = (0, ((obj = require("css-select-base-adapter")) && obj.__esModule ? obj : {
  default: obj
}).default)({
  isTag: function(node) {
    return node.isElem();
  },
  getParent: function(node) {
    return node.parentNode || null;
  },
  getChildren: function(node) {
    return node.content || [];
  },
  getName: function(elemAst) {
    return elemAst.elem;
  },
  getText: function(node) {
    return node.content[0].text || node.content[0].cdata || "";
  },
  getAttributeValue: function(elem, name) {
    return elem.hasAttr(name) ? elem.attr(name).value : null;
  }
});

exports.svgoCssSelectAdapter = svgoCssSelectAdapter;