"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.sortDefsChildren = exports.sortAttrs = exports.reusePaths = exports.removeXMLProcInst = exports.removeXMLNS = exports.removeViewBox = exports.removeUselessStrokeAndFill = exports.removeUselessDefs = exports.removeUnusedNS = exports.removeUnknownsAndDefaults = exports.removeTitle = exports.removeStyleElement = exports.removeScriptElement = exports.removeRasterImages = exports.removeOffCanvasPaths = exports.removeNonInheritableGroupAttrs = exports.removeMetadata = exports.removeHiddenElems = exports.removeEmptyText = exports.removeEmptyContainers = exports.removeEmptyAttrs = exports.removeElementsByAttr = exports.removeEditorsNSData = exports.removeDoctype = exports.removeDimensions = exports.removeDesc = exports.removeComments = exports.removeAttrs = exports.removeAttributesBySelector = exports.prefixIds = exports.moveGroupAttrsToElems = exports.moveElemsAttrsToGroup = exports.minifyStyles = exports.mergePaths = exports.inlineStyles = exports.convertTransform = exports.convertStyleToAttrs = exports.convertShapeToPath = exports.convertPathData = exports.convertEllipseToCircle = exports.convertColors = exports.collapseGroups = exports.cleanupNumericValues = exports.cleanupListOfValues = exports.cleanupIDs = exports.cleanupEnableBackground = exports.cleanupAttrs = exports.addClassesToSVGElement = exports.addAttributesToSVGElement = void 0;

var addAttributesToSVGElement = _interopRequireWildcard(require("./addAttributesToSVGElement"));

exports.addAttributesToSVGElement = addAttributesToSVGElement;

var addClassesToSVGElement = _interopRequireWildcard(require("./addClassesToSVGElement"));

exports.addClassesToSVGElement = addClassesToSVGElement;

var cleanupAttrs = _interopRequireWildcard(require("./cleanupAttrs"));

exports.cleanupAttrs = cleanupAttrs;

var cleanupEnableBackground = _interopRequireWildcard(require("./cleanupEnableBackground"));

exports.cleanupEnableBackground = cleanupEnableBackground;

var cleanupIDs = _interopRequireWildcard(require("./cleanupIDs"));

exports.cleanupIDs = cleanupIDs;

var cleanupListOfValues = _interopRequireWildcard(require("./cleanupListOfValues"));

exports.cleanupListOfValues = cleanupListOfValues;

var cleanupNumericValues = _interopRequireWildcard(require("./cleanupNumericValues"));

exports.cleanupNumericValues = cleanupNumericValues;

var collapseGroups = _interopRequireWildcard(require("./collapseGroups"));

exports.collapseGroups = collapseGroups;

var convertColors = _interopRequireWildcard(require("./convertColors"));

exports.convertColors = convertColors;

var convertEllipseToCircle = _interopRequireWildcard(require("./convertEllipseToCircle"));

exports.convertEllipseToCircle = convertEllipseToCircle;

var convertPathData = _interopRequireWildcard(require("./convertPathData"));

exports.convertPathData = convertPathData;

var convertShapeToPath = _interopRequireWildcard(require("./convertShapeToPath"));

exports.convertShapeToPath = convertShapeToPath;

var convertStyleToAttrs = _interopRequireWildcard(require("./convertStyleToAttrs"));

exports.convertStyleToAttrs = convertStyleToAttrs;

var convertTransform = _interopRequireWildcard(require("./convertTransform"));

exports.convertTransform = convertTransform;

var inlineStyles = _interopRequireWildcard(require("./inlineStyles"));

exports.inlineStyles = inlineStyles;

var mergePaths = _interopRequireWildcard(require("./mergePaths"));

exports.mergePaths = mergePaths;

var minifyStyles = _interopRequireWildcard(require("./minifyStyles"));

exports.minifyStyles = minifyStyles;

var moveElemsAttrsToGroup = _interopRequireWildcard(require("./moveElemsAttrsToGroup"));

exports.moveElemsAttrsToGroup = moveElemsAttrsToGroup;

var moveGroupAttrsToElems = _interopRequireWildcard(require("./moveGroupAttrsToElems"));

exports.moveGroupAttrsToElems = moveGroupAttrsToElems;

var prefixIds = _interopRequireWildcard(require("./prefixIds"));

exports.prefixIds = prefixIds;

var removeAttributesBySelector = _interopRequireWildcard(require("./removeAttributesBySelector"));

exports.removeAttributesBySelector = removeAttributesBySelector;

var removeAttrs = _interopRequireWildcard(require("./removeAttrs"));

exports.removeAttrs = removeAttrs;

var removeComments = _interopRequireWildcard(require("./removeComments"));

exports.removeComments = removeComments;

var removeDesc = _interopRequireWildcard(require("./removeDesc"));

exports.removeDesc = removeDesc;

var removeDimensions = _interopRequireWildcard(require("./removeDimensions"));

exports.removeDimensions = removeDimensions;

var removeDoctype = _interopRequireWildcard(require("./removeDoctype"));

exports.removeDoctype = removeDoctype;

var removeEditorsNSData = _interopRequireWildcard(require("./removeEditorsNSData"));

exports.removeEditorsNSData = removeEditorsNSData;

var removeElementsByAttr = _interopRequireWildcard(require("./removeElementsByAttr"));

exports.removeElementsByAttr = removeElementsByAttr;

var removeEmptyAttrs = _interopRequireWildcard(require("./removeEmptyAttrs"));

exports.removeEmptyAttrs = removeEmptyAttrs;

var removeEmptyContainers = _interopRequireWildcard(require("./removeEmptyContainers"));

exports.removeEmptyContainers = removeEmptyContainers;

var removeEmptyText = _interopRequireWildcard(require("./removeEmptyText"));

exports.removeEmptyText = removeEmptyText;

var removeHiddenElems = _interopRequireWildcard(require("./removeHiddenElems"));

exports.removeHiddenElems = removeHiddenElems;

var removeMetadata = _interopRequireWildcard(require("./removeMetadata"));

exports.removeMetadata = removeMetadata;

var removeNonInheritableGroupAttrs = _interopRequireWildcard(require("./removeNonInheritableGroupAttrs"));

exports.removeNonInheritableGroupAttrs = removeNonInheritableGroupAttrs;

var removeOffCanvasPaths = _interopRequireWildcard(require("./removeOffCanvasPaths"));

exports.removeOffCanvasPaths = removeOffCanvasPaths;

var removeRasterImages = _interopRequireWildcard(require("./removeRasterImages"));

exports.removeRasterImages = removeRasterImages;

var removeScriptElement = _interopRequireWildcard(require("./removeScriptElement"));

exports.removeScriptElement = removeScriptElement;

var removeStyleElement = _interopRequireWildcard(require("./removeStyleElement"));

exports.removeStyleElement = removeStyleElement;

var removeTitle = _interopRequireWildcard(require("./removeTitle"));

exports.removeTitle = removeTitle;

var removeUnknownsAndDefaults = _interopRequireWildcard(require("./removeUnknownsAndDefaults"));

exports.removeUnknownsAndDefaults = removeUnknownsAndDefaults;

var removeUnusedNS = _interopRequireWildcard(require("./removeUnusedNS"));

exports.removeUnusedNS = removeUnusedNS;

var removeUselessDefs = _interopRequireWildcard(require("./removeUselessDefs"));

exports.removeUselessDefs = removeUselessDefs;

var removeUselessStrokeAndFill = _interopRequireWildcard(require("./removeUselessStrokeAndFill"));

exports.removeUselessStrokeAndFill = removeUselessStrokeAndFill;

var removeViewBox = _interopRequireWildcard(require("./removeViewBox"));

exports.removeViewBox = removeViewBox;

var removeXMLNS = _interopRequireWildcard(require("./removeXMLNS"));

exports.removeXMLNS = removeXMLNS;

var removeXMLProcInst = _interopRequireWildcard(require("./removeXMLProcInst"));

exports.removeXMLProcInst = removeXMLProcInst;

var reusePaths = _interopRequireWildcard(require("./reusePaths"));

exports.reusePaths = reusePaths;

var sortAttrs = _interopRequireWildcard(require("./sortAttrs"));

exports.sortAttrs = sortAttrs;

var sortDefsChildren = _interopRequireWildcard(require("./sortDefsChildren"));

exports.sortDefsChildren = sortDefsChildren;

function _getRequireWildcardCache() {
  if ("function" != typeof WeakMap) return null;
  var cache = new WeakMap;
  _getRequireWildcardCache = function() {
    return cache;
  };
  return cache;
}

function _interopRequireWildcard(obj) {
  if (obj && obj.__esModule) return obj;
  if (null === obj || "object" != typeof obj && "function" != typeof obj) return {
    default: obj
  };
  var cache = _getRequireWildcardCache();
  if (cache && cache.has(obj)) return cache.get(obj);
  var newObj = {};
  var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var key in obj) if (Object.prototype.hasOwnProperty.call(obj, key)) {
    var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
    desc && (desc.get || desc.set) ? Object.defineProperty(newObj, key, desc) : newObj[key] = obj[key];
  }
  newObj.default = obj;
  cache && cache.set(obj, newObj);
  return newObj;
}