"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.PLUGINS_DEFAULT_LIST = void 0;

function _getRequireWildcardCache() {
  if ("function" != typeof WeakMap) return null;
  var cache = new WeakMap;
  _getRequireWildcardCache = function() {
    return cache;
  };
  return cache;
}

function _interopRequireWildcard(obj) {
  if (obj && obj.__esModule) return obj;
  if (null === obj || "object" != typeof obj && "function" != typeof obj) return {
    default: obj
  };
  var cache = _getRequireWildcardCache();
  if (cache && cache.has(obj)) return cache.get(obj);
  var newObj = {};
  var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var key in obj) if (Object.prototype.hasOwnProperty.call(obj, key)) {
    var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
    desc && (desc.get || desc.set) ? Object.defineProperty(newObj, key, desc) : newObj[key] = obj[key];
  }
  newObj.default = obj;
  cache && cache.set(obj, newObj);
  return newObj;
}

const PLUGINS_DEFAULT_LIST = [ _interopRequireWildcard(require("./cleanupAttrs")), _interopRequireWildcard(require("./cleanupEnableBackground")), _interopRequireWildcard(require("./cleanupIDs")), _interopRequireWildcard(require("./cleanupNumericValues")), _interopRequireWildcard(require("./collapseGroups")), _interopRequireWildcard(require("./convertColors")), _interopRequireWildcard(require("./convertEllipseToCircle")), _interopRequireWildcard(require("./convertPathData")), _interopRequireWildcard(require("./convertShapeToPath")), _interopRequireWildcard(require("./convertStyleToAttrs")), _interopRequireWildcard(require("./convertTransform")), _interopRequireWildcard(require("./inlineStyles")), _interopRequireWildcard(require("./mergePaths")), _interopRequireWildcard(require("./minifyStyles")), _interopRequireWildcard(require("./moveElemsAttrsToGroup")), _interopRequireWildcard(require("./moveGroupAttrsToElems")), _interopRequireWildcard(require("./removeComments")), _interopRequireWildcard(require("./removeDesc")), _interopRequireWildcard(require("./removeDoctype")), _interopRequireWildcard(require("./removeEditorsNSData")), _interopRequireWildcard(require("./removeEmptyAttrs")), _interopRequireWildcard(require("./removeEmptyContainers")), _interopRequireWildcard(require("./removeEmptyText")), _interopRequireWildcard(require("./removeHiddenElems")), _interopRequireWildcard(require("./removeMetadata")), _interopRequireWildcard(require("./removeNonInheritableGroupAttrs")), _interopRequireWildcard(require("./removeTitle")), _interopRequireWildcard(require("./removeUnknownsAndDefaults")), _interopRequireWildcard(require("./removeUnusedNS")), _interopRequireWildcard(require("./removeUselessDefs")), _interopRequireWildcard(require("./removeUselessStrokeAndFill")), _interopRequireWildcard(require("./removeViewBox")), _interopRequireWildcard(require("./removeXMLProcInst")), _interopRequireWildcard(require("./sortDefsChildren")) ];

exports.PLUGINS_DEFAULT_LIST = PLUGINS_DEFAULT_LIST;