"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

var _collections = require("./_collections");

const animationElems = _collections.elemsGroups.animation;

exports.name = "collapseGroups";

exports.type = "perItemReverse";

exports.active = !0;

exports.description = "collapses useless groups";

exports.params = {};

function hasAnimatedAttr(item) {
  return item.isElem(animationElems) && item.hasAttr("attributeName", this) || !item.isEmpty() && item.content.some(hasAnimatedAttr, this);
}

exports.fn = function(item) {
  !item.isElem() || item.isElem("switch") || item.isEmpty() || item.content.forEach((function(g, i) {
    if (g.isElem("g") && !g.isEmpty()) {
      if (g.hasAttr() && 1 === g.content.length) {
        const inner = g.content[0];
        !inner.isElem() || inner.hasAttr("id") || g.hasAttr("filter") || g.hasAttr("class") && inner.hasAttr("class") || (g.hasAttr("clip-path") || g.hasAttr("mask")) && (!inner.isElem("g") || g.hasAttr("transform") || inner.hasAttr("transform")) || g.eachAttr((function(attr) {
          if (!g.content.some(hasAnimatedAttr, attr.name)) {
            if (inner.hasAttr(attr.name)) {
              if ("transform" === attr.name) inner.attr(attr.name).value = attr.value + " " + inner.attr(attr.name).value; else if (inner.hasAttr(attr.name, "inherit")) inner.attr(attr.name).value = attr.value; else if (_collections.inheritableAttrs.indexOf(attr.name) < 0 && !inner.hasAttr(attr.name, attr.value)) return;
            } else inner.addAttr(attr);
            g.removeAttr(attr.name);
          }
        }));
      }
      g.hasAttr() || g.content.some((function(item) {
        return item.isElem(animationElems);
      })) || item.spliceContent(i, 1, g.content);
    }
  }));
};