"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

var _collections = require("./_collections");

exports.name = "moveElemsAttrsToGroup";

exports.type = "perItemReverse";

exports.active = !0;

exports.description = "moves elements attributes to the existing group wrapper";

exports.params = {};

exports.fn = function(item) {
  if (item.isElem("g") && !item.isEmpty() && item.content.length > 1) {
    let intersection = {};
    let hasTransform = !1;
    const hasClip = item.hasAttr("clip-path") || item.hasAttr("mask");
    const intersected = item.content.every((function(inner) {
      if (inner.isElem() && inner.hasAttr()) {
        if (inner.hasAttr("class")) return !1;
        if (Object.keys(intersection).length) {
          intersection = function(a, b) {
            const c = {};
            for (const n in a) Object.prototype.hasOwnProperty.call(b, n) && _collections.inheritableAttrs.indexOf(n) > -1 && a[n].name === b[n].name && a[n].value === b[n].value && a[n].prefix === b[n].prefix && a[n].local === b[n].local && (c[n] = a[n]);
            return !!Object.keys(c).length && c;
          }(intersection, inner.attrs);
          if (!intersection) return !1;
        } else intersection = inner.attrs;
        return !0;
      }
    }));
    const allPath = item.content.every((function(inner) {
      return inner.isElem(_collections.pathElems);
    }));
    intersected && item.content.forEach((function(g) {
      for (const name in intersection) if (!allPath && !hasClip || "transform" !== name) {
        g.removeAttr(name);
        if ("transform" === name) {
          if (!hasTransform) {
            item.hasAttr("transform") ? item.attr("transform").value += " " + intersection[name].value : item.addAttr(intersection[name]);
            hasTransform = !0;
          }
        } else item.addAttr(intersection[name]);
      }
    }));
  }
};