"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

exports.name = "removeDimensions";

exports.type = "perItem";

exports.active = !1;

exports.description = "removes width and height in presence of viewBox (opposite to removeViewBox, disable it first)";

exports.params = {};

exports.fn = function(item) {
  if (item.isElem("svg")) if (item.hasAttr("viewBox")) {
    item.removeAttr("width");
    item.removeAttr("height");
  } else if (item.hasAttr("width") && item.hasAttr("height") && !isNaN(Number(item.attr("width").value)) && !isNaN(Number(item.attr("height").value))) {
    item.addAttr({
      name: "viewBox",
      value: "0 0 " + Number(item.attr("width").value) + " " + Number(item.attr("height").value),
      prefix: "",
      local: "viewBox"
    });
    item.removeAttr("width");
    item.removeAttr("height");
  }
};