"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

var _collections = require("./_collections");

exports.name = "removeNonInheritableGroupAttrs";

exports.type = "perItem";

exports.active = !0;

exports.description = "removes non-inheritable group’s presentational attributes";

exports.params = {};

exports.fn = function(item) {
  item.isElem("g") && item.eachAttr((function(attr) {
    !~_collections.attrsGroups.presentation.indexOf(attr.name) || ~_collections.inheritableAttrs.indexOf(attr.name) || ~_collections.presentationNonInheritableGroupAttrs.indexOf(attr.name) || item.removeAttr(attr.name);
  }));
};