"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

exports.fn = exports.params = exports.description = exports.active = exports.type = exports.name = void 0;

exports.name = "removeViewBox";

exports.type = "perItem";

exports.active = !0;

exports.description = "removes viewBox attribute when possible";

exports.params = {};

const viewBoxElems = [ "svg", "pattern", "symbol" ];

exports.fn = function(item) {
  if (item.isElem(viewBoxElems) && item.hasAttr("viewBox") && item.hasAttr("width") && item.hasAttr("height")) {
    const nums = item.attr("viewBox").value.split(/[ ,]+/g);
    "0" === nums[0] && "0" === nums[1] && item.attr("width").value.replace(/px$/, "") === nums[2] && item.attr("height").value.replace(/px$/, "") === nums[3] && item.removeAttr("viewBox");
  }
};