"use strict"
Object.defineProperty(exports,"__esModule",{value:!0})
exports.fn=exports.params=exports.description=exports.active=exports.type=exports.name=void 0
var e=require("../lib/svgo/tools")
exports.name="cleanupNumericValues"
exports.type="perItem"
exports.active=!0
exports.description="rounds numeric values to the fixed precision, removes default ‘px’ units"
exports.params={floatPrecision:3,leadingZero:!0,defaultPx:!0,convertToPx:!0}
const t=/^([-+]?\d*\.?\d+([eE][-+]?\d+)?)(px|pt|pc|mm|cm|m|in|ft|em|ex|%)?$/
const o={cm:96/2.54,mm:96/25.4,in:96,pt:4/3,pc:16}
exports.fn=function(i,r){if(i.isElem()){const s=r.floatPrecision
if(i.hasAttr("viewBox")){const e=i.attr("viewBox").value.split(/\s,?\s*|,\s*/g)
i.attr("viewBox").value=e.map((function(e){const t=+e
return isNaN(t)?e:+t.toFixed(s)})).join(" ")}i.eachAttr((function(i){if("version"===i.name)return
const n=i.value.match(t)
if(n){let t=+(+n[1]).toFixed(s)
let a=n[3]||""
if(r.convertToPx&&a&&a in o){const e=+(o[a]*n[1]).toFixed(s)
if(String(e).length<n[0].length){t=e
a="px"}}r.leadingZero&&(t=(0,e.removeLeadingZero)(t))
r.defaultPx&&"px"===a&&(a="")
i.value=t+a}}))}}
