"use strict"
Object.defineProperty(exports,"__esModule",{value:!0})
exports.fn=exports.params=exports.description=exports.active=exports.type=exports.name=void 0
exports.name="convertShapeToPath"
exports.type="perItem"
exports.active=!0
exports.description="converts basic shapes to more compact path form"
exports.params={convertArcs:!1}
const t={value:0}
const e=/[-+]?(?:\d*\.\d+|\d+\.?)(?:[eE][-+]?\d+)?/g
exports.fn=function(r,a){const s=a&&a.convertArcs
if(r.isElem("rect")&&r.hasAttr("width")&&r.hasAttr("height")&&!r.hasAttr("rx")&&!r.hasAttr("ry")){const e=+(r.attr("x")||t).value
const a=+(r.attr("y")||t).value
const s=+r.attr("width").value
const o=+r.attr("height").value
if(isNaN(e-a+s-o))return
const l="M"+e+" "+a+"H"+(e+s)+"V"+(a+o)+"H"+e+"z"
r.addAttr({name:"d",value:l,prefix:"",local:"d"})
r.renameElem("path").removeAttr(["x","y","width","height"])}else if(r.isElem("line")){const e=+(r.attr("x1")||t).value
const a=+(r.attr("y1")||t).value
const s=+(r.attr("x2")||t).value
const o=+(r.attr("y2")||t).value
if(isNaN(e-a+s-o))return
r.addAttr({name:"d",value:"M"+e+" "+a+"L"+s+" "+o,prefix:"",local:"d"})
r.renameElem("path").removeAttr(["x1","y1","x2","y2"])}else if((r.isElem("polyline")||r.isElem("polygon"))&&r.hasAttr("points")){const t=(r.attr("points").value.match(e)||[]).map(Number)
if(t.length<4)return!1
r.addAttr({name:"d",value:"M"+t.slice(0,2).join(" ")+"L"+t.slice(2).join(" ")+(r.isElem("polygon")?"z":""),prefix:"",local:"d"})
r.renameElem("path").removeAttr("points")}else if(r.isElem("circle")&&s){const e=+(r.attr("cx")||t).value
const a=+(r.attr("cy")||t).value
const s=+(r.attr("r")||t).value
if(isNaN(e-a+s))return
const o="M"+e+" "+(a-s)+"A"+s+" "+s+" 0 1 0 "+e+" "+(a+s)+"A"+s+" "+s+" 0 1 0 "+e+" "+(a-s)+"Z"
r.addAttr({name:"d",value:o,prefix:"",local:"d"})
r.renameElem("path").removeAttr(["cx","cy","r"])}else if(r.isElem("ellipse")&&s){const e=+(r.attr("cx")||t).value
const a=+(r.attr("cy")||t).value
const s=+(r.attr("rx")||t).value
const o=+(r.attr("ry")||t).value
if(isNaN(e-a+s-o))return
const l="M"+e+" "+(a-o)+"A"+s+" "+o+" 0 1 0 "+e+" "+(a+o)+"A"+s+" "+o+" 0 1 0 "+e+" "+(a-o)+"Z"
r.addAttr({name:"d",value:l,prefix:"",local:"d"})
r.renameElem("path").removeAttr(["cx","cy","rx","ry"])}}
