"use strict"
Object.defineProperty(exports,"__esModule",{value:!0})
exports.fn=exports.params=exports.description=exports.active=exports.type=exports.name=void 0
var e=(t=require("css-tree"))&&t.__esModule?t:{default:t}
var t
var s=require("../lib/css-tools")
exports.name="inlineStyles"
exports.type="full"
exports.active=!0
exports.params={onlyMatchedOnce:!0,removeMatchedSelectors:!0,useMqs:["","screen"],usePseudos:[""]}
exports.description="inline styles (additional options)"
exports.fn=function(t,l){const r=t.querySelectorAll("style")
if(null===r)return t
const o=[]
let n=[]
for(const t of r){if(t.isEmpty()||t.closestElem("foreignObject"))continue
const l=(0,s.getCssStr)(t)
let r={}
try{r=e.default.parse(l,{parseValue:!1,parseCustomProperty:!1})}catch(e){continue}o.push({styleEl:t,cssAst:r})
n=n.concat((0,s.flattenToSelectors)(r))}const c=(0,s.filterByMqs)(n,l.useMqs)
const i=(0,s.filterByPseudos)(c,l.usePseudos);(0,s.cleanPseudos)(i)
const a=(0,s.sortSelectors)(i).reverse()
let u
let d
for(u of a){const s=e.default.generate(u.item.data)
let l=null
try{l=t.querySelectorAll(s)}catch(e){if(e.message.includes("Unmatched selector:"))continue
throw e}null!==l&&(u.selectedEls=l)}for(u of a)if(u.selectedEls&&!(l.onlyMatchedOnce&&null!==u.selectedEls&&u.selectedEls.length>1)){for(d of u.selectedEls)null!==u.rule&&e.default.walk(u.rule,{visit:"Declaration",enter:function(e){const t=(0,s.csstreeToStyleDeclaration)(e)
null!==d.style.getPropertyValue(t.name)&&d.style.getPropertyPriority(t.name)>=t.priority||d.style.setProperty(t.name,t.value,t.priority)}})
l.removeMatchedSelectors&&null!==u.selectedEls&&u.selectedEls.length>0&&u.rule.prelude.children.remove(u.item)}if(!l.removeMatchedSelectors)return t
for(u of a)if(u.selectedEls&&!(l.onlyMatchedOnce&&null!==u.selectedEls&&u.selectedEls.length>1))for(d of u.selectedEls){const e=u.item.data.children.first()
"ClassSelector"===e.type&&d.class.remove(e.name)
void 0===d.class.item(0)&&d.removeAttr("class")
"IdSelector"===e.type&&d.removeAttr("id",e.name)}for(const t of o){e.default.walk(t.cssAst,{visit:"Rule",enter:function(e,t,s){("Atrule"===e.type&&null!==e.block&&e.block.children.isEmpty()||"Rule"===e.type&&e.prelude.children.isEmpty())&&s.remove(t)}})
if(t.cssAst.children.isEmpty()){const e=t.styleEl.parentNode
e.spliceContent(e.content.indexOf(t.styleEl),1)
if("defs"===e.elem&&0===e.content.length){const t=e.parentNode
t.spliceContent(t.content.indexOf(e),1)}}else(0,s.setCssStr)(t.styleEl,e.default.generate(t.cssAst))}return t}
